## libtoxcore 0.2.2

=== CMakeLists.txt ===
################################################################################
#
# The main toxcore CMake build file.
#
# This file when processed with cmake produces:
# - A number of small libraries (.a/.so/...) containing independent components
#   of toxcore. E.g. the DHT has its own library, and the system/network
#   abstractions are in their own library as well. These libraries are not
#   installed on `make install`. The toxav, and toxencryptsave libraries are
#   also not installed.
# - A number of small programs, statically linked if possible.
# - One big library containing all of the toxcore, toxav, and toxencryptsave
#   code.
#
################################################################################

cmake_minimum_required(VERSION 2.8.12)
cmake_policy(VERSION 2.8.12)
project(toxcore)

set(CMAKE_MODULE_PATH ${toxcore_SOURCE_DIR}/cmake)

################################################################################
#
# :: Version management
#
################################################################################

# This version is for the entire project. All libraries (core, av, ...) move in
# versions in a synchronised way.
set(PROJECT_VERSION_MAJOR "0")
set(PROJECT_VERSION_MINOR "2")
set(PROJECT_VERSION_PATCH "2")
set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")

# set .so library version / following libtool scheme
# https://www.gnu.org/software/libtool/manual/libtool.html#Updating-version-info
file(STRINGS ${toxcore_SOURCE_DIR}/so.version SOVERSION_CURRENT REGEX "^CURRENT=[0-9]+$")
string(SUBSTRING "${SOVERSION_CURRENT}" 8 -1 SOVERSION_CURRENT)
file(STRINGS ${toxcore_SOURCE_DIR}/so.version SOVERSION_REVISION REGEX "^REVISION=[0-9]+$")
string(SUBSTRING "${SOVERSION_REVISION}" 9 -1 SOVERSION_REVISION)
file(STRINGS ${toxcore_SOURCE_DIR}/so.version SOVERSION_AGE REGEX "^AGE=[0-9]+$")
string(SUBSTRING "${SOVERSION_AGE}" 4 -1 SOVERSION_AGE)
# account for some libtool magic, see other/version-sync script for details
math(EXPR SOVERSION_MAJOR ${SOVERSION_CURRENT}-${SOVERSION_AGE})
set(SOVERSION "${SOVERSION_MAJOR}.${SOVERSION_AGE}.${SOVERSION_REVISION}")
message("SOVERSION: ${SOVERSION}")

################################################################################
#
# :: Dependencies and configuration
#
################################################################################

include(AddCompilerFlag)
include(ApiDsl)
include(ModulePackage)
include(StrictAbi)
include(GNUInstallDirs)

if(APPLE)
  include(MacRpath)
endif()

enable_testing()

set(CMAKE_MACOSX_RPATH ON)

if(${CMAKE_VERSION} VERSION_LESS "3.1.0")
  add_cflag("-std=c99")
  add_cxxflag("-std=c++11")
else()
  # Set standard version for compiler.
  set(CMAKE_C_STANDARD 99)
  set(CMAKE_CXX_STANDARD 11)
  set(CMAKE_C_EXTENSIONS OFF)
  set(CMAKE_CXX_EXTENSIONS OFF)

  message(STATUS "Supported C compiler features = ${CMAKE_C_COMPILE_FEATURES}")
  message(STATUS "Supported C++ compiler features = ${CMAKE_CXX_COMPILE_FEATURES}")
endif()

if(NOT MSVC)
  # Warn on non-ISO C.
  add_cflag("-pedantic")

  option(ERROR_ON_WARNING "Make compilation error on a warning" OFF)
  if(ERROR_ON_WARNING)
    add_flag("-Werror")
  endif()

  option(COVERAGE "Track code coverage" OFF)
  if(COVERAGE)
    add_flag("-fprofile-instr-generate")
    add_flag("-fcoverage-mapping")
  endif()

  option(DEBUG "Enable assertions and other debugging facilities" OFF)
  if(DEBUG)
    set(MIN_LOGGER_LEVEL DEBUG)
    add_cflag("-g3")
    if(MINGW)
      # Allows wine to display source code file names and line numbers on crash in its backtrace
      add_flag("-gdwarf-2")
    endif()
  endif()

  option(WARNINGS "Enable additional compiler warnings" ON)
  if(WARNINGS)
    # Add all warning flags we can.
    add_flag("-Wall")
    add_flag("-Wextra")
    add_flag("-Weverything")

    # Disable specific warning flags for both C and C++.

    # TODO(iphydf): Clean these up. Probably all of these are actual bugs.
    add_flag("-Wno-cast-align")
    # Very verbose, not very useful. This warns about things like int -> uint
    # conversions that change sign without a cast and narrowing conversions.
    add_flag("-Wno-conversion")
    # TODO(iphydf): Check enum values when received from the user, then assume
    # correctness and remove this suppression.
    add_flag("-Wno-covered-switch-default")
    # Due to clang's tolower() macro being recursive
    # https://github.com/TokTok/c-toxcore/pull/481
    add_flag("-Wno-disabled-macro-expansion")
    # We don't put __attribute__ on the public API.
    add_flag("-Wno-documentation-deprecated-sync")
    # Bootstrap daemon does this.
    add_flag("-Wno-format-nonliteral")
    # struct Foo foo = {0}; is a common idiom.
    add_flag("-Wno-missing-field-initializers")
    # Useful sometimes, but we accept padding in structs for clarity.
    # Reordering fields to avoid padding will reduce readability.
    add_flag("-Wno-padded")
    # This warns on things like _XOPEN_SOURCE, which we currently need (we
    # probably won't need these in the future).
    add_flag("-Wno-reserved-id-macro")
    # TODO(iphydf): Clean these up. They are likely not bugs, but still
    # potential issues and probably confusing.
    add_flag("-Wno-sign-compare")
    # Our use of mutexes results in a false positive, see 1bbe446.
    add_flag("-Wno-thread-safety-analysis")
    # File transfer code has this.
    add_flag("-Wno-type-limits")
    # Callbacks often don't use all their parameters.
    add_flag("-Wno-unused-parameter")
    # libvpx uses __attribute__((unused)) for "potentially unused" static
    # functions to avoid unused static function warnings.
    add_flag("-Wno-used-but-marked-unused")
    # We use variable length arrays a lot.
    add_flag("-Wno-vla")

    # Disable specific warning flags for C++.

    # Comma at end of enum is supported everywhere we run.
    add_cxxflag("-Wno-c++98-compat-pedantic")
    # TODO(iphydf): Stop using flexible array members.
    add_cxxflag("-Wno-c99-extensions")
    # We're C-compatible, so use C style casts.
    add_cxxflag("-Wno-old-style-cast")

    # Downgrade to warning so we still see it.
    add_flag("-Wno-error=unused-variable")
  endif()
endif()

option(TRACE "Enable TRACE level logging (expensive, for network debugging)" OFF)
if(TRACE)
  set(MIN_LOGGER_LEVEL TRACE)
endif()

if(MIN_LOGGER_LEVEL)
  add_definitions(-DMIN_LOGGER_LEVEL=LOG_${MIN_LOGGER_LEVEL})
endif()

option(ASAN "Enable address-sanitizer to detect invalid memory accesses" OFF)
if(ASAN)
  set(SAFE_CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES}")
  set(CMAKE_REQUIRED_LIBRARIES "-fsanitize=address")
  add_cflag("-fsanitize=address")
  set(CMAKE_REQUIRED_LIBRARIES "${SAFE_CMAKE_REQUIRED_LIBRARIES}")
else()
  # Forbid undefined symbols in shared libraries. This is incompatible with
  # asan, so it's in the else branch here.
  if(APPLE)
    add_dllflag("-undefined error")
  else()
    add_dllflag("-Wl,-z,defs")
  endif()
endif()

option(USE_IPV6 "Use IPv6 in tests" ON)
if(NOT USE_IPV6)
  add_definitions(-DUSE_IPV6=0)
endif()

option(USE_STDERR_LOGGER "Enable logging to stderr when the logger is NULL" OFF)
if(USE_STDERR_LOGGER)
  add_definitions(-DUSE_STDERR_LOGGER=1)
endif()

option(BUILD_TOXAV "Whether to build the tox AV library" ON)
option(MUST_BUILD_TOXAV "Fail the build if toxav cannot be built" OFF)

include(Dependencies)

if(MUST_BUILD_TOXAV)
  set(NO_TOXAV_ERROR_TYPE SEND_ERROR)
else()
  set(NO_TOXAV_ERROR_TYPE WARNING)
endif()

if(BUILD_TOXAV)
  if(NOT OPUS_FOUND)
    message(${NO_TOXAV_ERROR_TYPE} "Option BUILD_TOXAV is enabled but required library OPUS was not found.")
    set(BUILD_TOXAV OFF)
  endif()
  if(NOT VPX_FOUND)
    message(${NO_TOXAV_ERROR_TYPE} "Option BUILD_TOXAV is enabled but required library VPX was not found.")
    set(BUILD_TOXAV OFF)
  endif()
endif()

################################################################################
#
# :: Tox Core Library
#
################################################################################

# toxcore_PKGCONFIG_LIBS is what's added to the Libs: line in toxcore.pc. It
# needs to contain all the libraries a program using toxcore should link against
# if it's statically linked. If it's dynamically linked, there is no need to
# explicitly link against all the dependencies, but it doesn't harm much(*)
# either.
#
# (*) It allows client code to use symbols from our dependencies without
#    explicitly linking against them.
set(toxcore_PKGCONFIG_LIBS)
# Requires: in pkg-config file.
set(toxcore_PKGCONFIG_REQUIRES)

# LAYER 1: Crypto core
# --------------------
apidsl(toxcore/crypto_core.api.h)
set(toxcore_SOURCES ${toxcore_SOURCES}
  toxcore/ccompat.h
  toxcore/crypto_core.c
  toxcore/crypto_core.h
  toxcore/crypto_core_mem.c)
include(CheckFunctionExists)
check_function_exists(explicit_bzero HAVE_EXPLICIT_BZERO)
check_function_exists(memset_s HAVE_MEMSET_S)
set(toxcore_LINK_MODULES ${toxcore_LINK_MODULES} ${LIBSODIUM_LIBRARIES})
set(toxcore_PKGCONFIG_REQUIRES ${toxcore_PKGCONFIG_REQUIRES} libsodium)

# LAYER 2: Basic networking
# -------------------------
set(toxcore_SOURCES ${toxcore_SOURCES}
  toxcore/logger.c
  toxcore/logger.h
  toxcore/network.c
  toxcore/network.h
  toxcore/util.c
  toxcore/util.h)

# LAYER 3: Distributed Hash Table
# -------------------------------
apidsl(toxcore/LAN_discovery.api.h)
apidsl(toxcore/ping.api.h)
apidsl(toxcore/ping_array.api.h)
set(toxcore_SOURCES ${toxcore_SOURCES}
  toxcore/DHT.c
  toxcore/DHT.h
  toxcore/LAN_discovery.c
  toxcore/LAN_discovery.h
  toxcore/ping.c
  toxcore/ping.h
  toxcore/ping_array.c
  toxcore/ping_array.h)

# LAYER 4: Onion routing, TCP connections, crypto connections
# -----------------------------------------------------------
set(toxcore_SOURCES ${toxcore_SOURCES}
  toxcore/TCP_client.c
  toxcore/TCP_client.h
  toxcore/TCP_connection.c
  toxcore/TCP_connection.h
  toxcore/TCP_server.c
  toxcore/TCP_server.h
  toxcore/list.c
  toxcore/list.h
  toxcore/net_crypto.c
  toxcore/net_crypto.h
  toxcore/onion.c
  toxcore/onion.h
  toxcore/onion_announce.c
  toxcore/onion_announce.h
  toxcore/onion_client.c
  toxcore/onion_client.h)

# LAYER 5: Friend requests and connections
# ----------------------------------------
set(toxcore_SOURCES ${toxcore_SOURCES}
  toxcore/friend_connection.c
  toxcore/friend_connection.h
  toxcore/friend_requests.c
  toxcore/friend_requests.h)

# LAYER 6: Tox messenger
# ----------------------
set(toxcore_SOURCES ${toxcore_SOURCES}
  toxcore/Messenger.c
  toxcore/Messenger.h)

# LAYER 7: Group chats
# --------------------
set(toxcore_SOURCES ${toxcore_SOURCES}
  toxcore/group.c
  toxcore/group.h)

# LAYER 8: Public API
# -------------------
apidsl(toxcore/tox.api.h)
set(toxcore_SOURCES ${toxcore_SOURCES}
  toxcore/tox_api.c
  toxcore/tox.c
  toxcore/tox.h)
set(toxcore_API_HEADERS ${toxcore_API_HEADERS} ${toxcore_SOURCE_DIR}/toxcore/tox.h^tox)

################################################################################
#
# :: Audio/Video Library
#
################################################################################

if(BUILD_TOXAV)
  apidsl(toxav/toxav.api.h)
  set(toxcore_SOURCES ${toxcore_SOURCES}
    toxav/audio.c
    toxav/audio.h
    toxav/bwcontroller.c
    toxav/bwcontroller.h
    toxav/groupav.c
    toxav/groupav.h
    toxav/msi.c
    toxav/msi.h
    toxav/ring_buffer.c
    toxav/ring_buffer.h
    toxav/rtp.c
    toxav/rtp.h
    toxav/toxav.c
    toxav/toxav.h
    toxav/toxav_old.c
    toxav/video.c
    toxav/video.h)
  set(toxcore_LINK_MODULES ${toxcore_LINK_MODULES} ${OPUS_LIBRARIES} ${VPX_LIBRARIES})
  set(toxcore_PKGCONFIG_REQUIRES ${toxcore_PKGCONFIG_REQUIRES} opus vpx)

  set(toxcore_API_HEADERS ${toxcore_API_HEADERS} ${toxcore_SOURCE_DIR}/toxav/toxav.h^toxav)
endif()

################################################################################
#
# :: Block encryption libraries
#

=== debian/changelog ===
libtoxcore (0.2.2-1) unstable; urgency=medium

  * New upstream release
  * Fix FTBFS on hurd-i386
  * Disable buggy autotest

 -- Yangfl <mmyangfl@gmail.com>  Thu, 31 May 2018 01:56:04 +0800

libtoxcore (0.2.0-1) unstable; urgency=medium

  * Initial release (Closes: #739860)

 -- Yangfl <mmyangfl@gmail.com>  Thu, 01 Mar 2018 13:14:54 +0800

=== debian/control ===
Source: libtoxcore
Priority: optional
Maintainer: Yangfl <mmyangfl@gmail.com>
Build-Depends:
 debhelper (>= 11~),
 cmake,
 pkg-config,
 libncurses5-dev,
 libopus-dev,
 libsodium-dev,
 libvpx-dev,
Standards-Version: 4.1.4
Section: libs
Homepage: https://tox.chat
Vcs-Git: https://salsa.debian.org/yangfl-guest/c-toxcore.git
Vcs-Browser: https://salsa.debian.org/yangfl-guest/c-toxcore

Package: libtoxcore2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Distributed, secure messenger
 Tox provides an encrypted, distributed, and extensible peer-to-peer platform
 that can be used for various forms of communication. Tox is intended to be used
 as a multimedia messenger, but many people have shown that Tox can be used for
 a lot more than just instant messaging.

Package: libtoxcore-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, libtoxcore2 (= ${binary:Version}), libsodium-dev
Description: Distributed, secure messenger - development headers
 Tox provides an encrypted, distributed, and extensible peer-to-peer platform
 that can be used for various forms of communication. Tox is intended to be used
 as a multimedia messenger, but many people have shown that Tox can be used for
 a lot more than just instant messaging.
 .
 This package contains the development headers.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --buildsystem=cmake

.PHONY: build
build:
	dh build --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DTEST_TIMEOUT_SECONDS=120

# iphy@#toktok: some of the tests use 100 ports
# And tox limits the range of ports it tries to 33445-33545 (101 ports)
override_dh_auto_test:
#	dh_auto_test --no-parallel
# buggy - fail nearly everytime

## libtoxcore 0.2.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,7 +30,7 @@
 # versions in a synchronised way.
 set(PROJECT_VERSION_MAJOR "0")
 set(PROJECT_VERSION_MINOR "2")
-set(PROJECT_VERSION_PATCH "2")
+set(PROJECT_VERSION_PATCH "9")
 set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
 
 # set .so library version / following libtool scheme
@@ -52,8 +52,8 @@
 #
 ################################################################################
 
-include(AddCompilerFlag)
 include(ApiDsl)
+include(CTest)
 include(ModulePackage)
 include(StrictAbi)
 include(GNUInstallDirs)
@@ -67,8 +67,10 @@
 set(CMAKE_MACOSX_RPATH ON)
 
 if(${CMAKE_VERSION} VERSION_LESS "3.1.0")
-  add_cflag("-std=c99")
-  add_cxxflag("-std=c++11")
+  if(NOT MSVC)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
+  endif()
 else()
   # Set standard version for compiler.
   set(CMAKE_C_STANDARD 99)
@@ -80,114 +82,16 @@
   message(STATUS "Supported C++ compiler features = ${CMAKE_CXX_COMPILE_FEATURES}")
 endif()
 
-if(NOT MSVC)
-  # Warn on non-ISO C.
-  add_cflag("-pedantic")
-
-  option(ERROR_ON_WARNING "Make compilation error on a warning" OFF)
-  if(ERROR_ON_WARNING)
-    add_flag("-Werror")
-  endif()
-
-  option(COVERAGE "Track code coverage" OFF)
-  if(COVERAGE)
-    add_flag("-fprofile-instr-generate")
-    add_flag("-fcoverage-mapping")
-  endif()
-
-  option(DEBUG "Enable assertions and other debugging facilities" OFF)
-  if(DEBUG)
-    set(MIN_LOGGER_LEVEL DEBUG)
-    add_cflag("-g3")
-    if(MINGW)
-      # Allows wine to display source code file names and line numbers on crash in its backtrace
-      add_flag("-gdwarf-2")
-    endif()
-  endif()
-
-  option(WARNINGS "Enable additional compiler warnings" ON)
-  if(WARNINGS)
-    # Add all warning flags we can.
-    add_flag("-Wall")
-    add_flag("-Wextra")
-    add_flag("-Weverything")
-
-    # Disable specific warning flags for both C and C++.
-
-    # TODO(iphydf): Clean these up. Probably all of these are actual bugs.
-    add_flag("-Wno-cast-align")
-    # Very verbose, not very useful. This warns about things like int -> uint
-    # conversions that change sign without a cast and narrowing conversions.
-    add_flag("-Wno-conversion")
-    # TODO(iphydf): Check enum values when received from the user, then assume
-    # correctness and remove this suppression.
-    add_flag("-Wno-covered-switch-default")
-    # Due to clang's tolower() macro being recursive
-    # https://github.com/TokTok/c-toxcore/pull/481
-    add_flag("-Wno-disabled-macro-expansion")
-    # We don't put __attribute__ on the public API.
-    add_flag("-Wno-documentation-deprecated-sync")
-    # Bootstrap daemon does this.
-    add_flag("-Wno-format-nonliteral")
-    # struct Foo foo = {0}; is a common idiom.
-    add_flag("-Wno-missing-field-initializers")
-    # Useful sometimes, but we accept padding in structs for clarity.
-    # Reordering fields to avoid padding will reduce readability.
-    add_flag("-Wno-padded")
-    # This warns on things like _XOPEN_SOURCE, which we currently need (we
-    # probably won't need these in the future).
-    add_flag("-Wno-reserved-id-macro")
-    # TODO(iphydf): Clean these up. They are likely not bugs, but still
-    # potential issues and probably confusing.
-    add_flag("-Wno-sign-compare")
-    # Our use of mutexes results in a false positive, see 1bbe446.
-    add_flag("-Wno-thread-safety-analysis")
-    # File transfer code has this.
-    add_flag("-Wno-type-limits")
-    # Callbacks often don't use all their parameters.
-    add_flag("-Wno-unused-parameter")
-    # libvpx uses __attribute__((unused)) for "potentially unused" static
-    # functions to avoid unused static function warnings.
-    add_flag("-Wno-used-but-marked-unused")
-    # We use variable length arrays a lot.
-    add_flag("-Wno-vla")
-
-    # Disable specific warning flags for C++.
-
-    # Comma at end of enum is supported everywhere we run.
-    add_cxxflag("-Wno-c++98-compat-pedantic")
-    # TODO(iphydf): Stop using flexible array members.
-    add_cxxflag("-Wno-c99-extensions")
-    # We're C-compatible, so use C style casts.
-    add_cxxflag("-Wno-old-style-cast")
-
-    # Downgrade to warning so we still see it.
-    add_flag("-Wno-error=unused-variable")
-  endif()
-endif()
-
-option(TRACE "Enable TRACE level logging (expensive, for network debugging)" OFF)
-if(TRACE)
-  set(MIN_LOGGER_LEVEL TRACE)
-endif()
-
+set(MIN_LOGGER_LEVEL "" CACHE STRING "Logging level to use (TRACE, DEBUG, INFO, WARNING, ERROR)")
 if(MIN_LOGGER_LEVEL)
-  add_definitions(-DMIN_LOGGER_LEVEL=LOG_${MIN_LOGGER_LEVEL})
-endif()
-
-option(ASAN "Enable address-sanitizer to detect invalid memory accesses" OFF)
-if(ASAN)
-  set(SAFE_CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES}")
-  set(CMAKE_REQUIRED_LIBRARIES "-fsanitize=address")
-  add_cflag("-fsanitize=address")
-  set(CMAKE_REQUIRED_LIBRARIES "${SAFE_CMAKE_REQUIRED_LIBRARIES}")
-else()
-  # Forbid undefined symbols in shared libraries. This is incompatible with
-  # asan, so it's in the else branch here.
-  if(APPLE)
-    add_dllflag("-undefined error")
+  if(("${MIN_LOGGER_LEVEL}" STREQUAL "TRACE") OR
+     ("${MIN_LOGGER_LEVEL}" STREQUAL "DEBUG") OR
+     ("${MIN_LOGGER_LEVEL}" STREQUAL "INFO") OR
+     ("${MIN_LOGGER_LEVEL}" STREQUAL "WARNING") OR
+     ("${MIN_LOGGER_LEVEL}" STREQUAL "ERROR"))
+    add_definitions(-DMIN_LOGGER_LEVEL=LOGGER_LEVEL_${MIN_LOGGER_LEVEL})
   else()
-    add_dllflag("-Wl,-z,defs")
+    message(FATAL_ERROR "Unknown value provided for MIN_LOGGER_LEVEL: \"${MIN_LOGGER_LEVEL}\", must be one of TRACE, DEBUG, INFO, WARNING or ERROR")
   endif()
 endif()
 
@@ -260,8 +164,12 @@
 set(toxcore_SOURCES ${toxcore_SOURCES}
   toxcore/logger.c
   toxcore/logger.h
+  toxcore/mono_time.c
+  toxcore/mono_time.h
   toxcore/network.c
   toxcore/network.h
+  toxcore/state.c
+  toxcore/state.h
   toxcore/util.c
   toxcore/util.h)
 
@@ -365,3 +273,96 @@
 #
 # :: Block encryption libraries
 #
+################################################################################
+
+apidsl(toxencryptsave/toxencryptsave.api.h)
+set(toxcore_SOURCES ${toxcore_SOURCES}
+  toxencryptsave/toxencryptsave.c
+  toxencryptsave/toxencryptsave.h)
+set(toxcore_API_HEADERS ${toxcore_API_HEADERS} ${toxcore_SOURCE_DIR}/toxencryptsave/toxencryptsave.h^tox)
+
+################################################################################
+#
+# :: System dependencies
+#
+################################################################################
+
+# These need to come after other dependencies, since e.g. libvpx may depend on
+# pthread, but doesn't list it in VPX_LIBRARIES. We're adding it here, after
+# any potential libvpx linking.
+message("CMAKE_THREAD_LIBS_INIT: ${CMAKE_THREAD_LIBS_INIT}")
+if(CMAKE_THREAD_LIBS_INIT)
+  set(toxcore_LINK_MODULES ${toxcore_LINK_MODULES} ${CMAKE_THREAD_LIBS_INIT})
+  set(toxcore_PKGCONFIG_LIBS ${toxcore_PKGCONFIG_LIBS} ${CMAKE_THREAD_LIBS_INIT})
+endif()
+
+
+if(NSL_LIBRARIES)
+  set(toxcore_LINK_MODULES ${toxcore_LINK_MODULES} ${NSL_LIBRARIES})
+  set(toxcore_PKGCONFIG_LIBS ${toxcore_PKGCONFIG_LIBS} -lnsl)
+endif()
+
+if(RT_LIBRARIES)
+  set(toxcore_LINK_MODULES ${toxcore_LINK_MODULES} ${RT_LIBRARIES})
+  set(toxcore_PKGCONFIG_LIBS ${toxcore_PKGCONFIG_LIBS} -lrt)
+endif()
+
+if(SOCKET_LIBRARIES)
+  set(toxcore_LINK_MODULES ${toxcore_LINK_MODULES} ${SOCKET_LIBRARIES})
+  set(toxcore_PKGCONFIG_LIBS ${toxcore_PKGCONFIG_LIBS} -lsocket)
+endif()
+
+if(WIN32)
+  set(toxcore_LINK_MODULES ${toxcore_LINK_MODULES} ws2_32 iphlpapi)
+  set(toxcore_PKGCONFIG_LIBS ${toxcore_PKGCONFIG_LIBS} -lws2_32 -liphlpapi)
+endif()
+
+################################################################################
+#
+# :: All layers together in one library for ease of use
+#
+################################################################################
+
+# Create combined library from all the sources.
+add_module(toxcore ${toxcore_SOURCES})
+
+# Link it to all dependencies.
+target_link_modules(toxcore ${toxcore_LINK_MODULES})
+
+# Make version script (on systems that support it) to limit symbol visibility.
+make_version_script(toxcore ${toxcore_API_HEADERS})
+
+# Generate pkg-config file, install library to "${CMAKE_INSTALL_LIBDIR}" and install headers to
+# "${CMAKE_INSTALL_INCLUDEDIR}/tox".
+install_module(toxcore DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/tox)
+
+################################################################################
+#
+# :: Unit tests: no networking, just pure function calls.
+#
+################################################################################
+
+include(CompileGTest)
+
+# The actual unit tests follow.
+#
+unit_test(toxav ring_buffer)
+unit_test(toxav rtp)
+unit_test(toxcore crypto_core)
+unit_test(toxcore mono_time)
+unit_test(toxcore ping_array)
+unit_test(toxcore util)
+
+################################################################################
+#
+# :: Automated regression tests: create a tox network and run integration tests
+#
+################################################################################
+
+add_library(misc_tools
+  testing/misc_tools.c
+  testing/misc_tools.h)
+target_link_modules(misc_tools toxcore)
+
+set(TEST_TIMEOUT_SECONDS "" CACHE STRING "Limit runtime of each test to the number of seconds specified")
+

=== debian/changelog ===
libtoxcore (0.2.9-1) unstable; urgency=medium

  * New upstream release
  * Add package toxcore-utils
  * Add autopkgtest
  * Bump Standards-Version to 4.3.0
  * Bump debhelper compat to 12

 -- Yangfl <mmyangfl@gmail.com>  Tue, 29 Jan 2019 14:36:37 +0800

libtoxcore (0.2.8-1) unstable; urgency=medium

  * New upstream release
  * Remove symbols that are considered private by upstream
  * Bump Standards-Version to 4.2.1
  * Add dep libopus-dev, libvpx-dev for libtoxcore-dev

 -- Yangfl <mmyangfl@gmail.com>  Tue, 06 Nov 2018 22:00:16 +0800

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,15 @@
 Priority: optional
 Maintainer: Yangfl <mmyangfl@gmail.com>
 Build-Depends:
- debhelper (>= 11~),
+ debhelper (>= 12~),
  cmake,
  pkg-config,
+ libconfig-dev,
  libncurses5-dev,
  libopus-dev,
  libsodium-dev,
  libvpx-dev,
-Standards-Version: 4.1.4
+Standards-Version: 4.3.0
 Section: libs
 Homepage: https://tox.chat
 Vcs-Git: https://salsa.debian.org/yangfl-guest/c-toxcore.git
@@ -29,7 +30,12 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: ${misc:Depends}, libtoxcore2 (= ${binary:Version}), libsodium-dev
+Depends:
+ ${misc:Depends},
+ libtoxcore2 (= ${binary:Version}),
+ libsodium-dev,
+ libopus-dev,
+ libvpx-dev,
 Description: Distributed, secure messenger - development headers
  Tox provides an encrypted, distributed, and extensible peer-to-peer platform
  that can be used for various forms of communication. Tox is intended to be used
@@ -37,3 +43,16 @@
  a lot more than just instant messaging.
  .
  This package contains the development headers.
+
+Package: toxcore-utils
+Architecture: any
+Section: net
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: Distributed, secure messenger - DHT bootstrap tools
+ Tox provides an encrypted, distributed, and extensible peer-to-peer platform
+ that can be used for various forms of communication. Tox is intended to be used
+ as a multimedia messenger, but many people have shown that Tox can be used for
+ a lot more than just instant messaging.
+ .
+ This package contains DHT bootstrap tools, including DHT_bootstrap and
+ tox-bootstrapd.

## libtoxcore 0.2.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,7 +30,7 @@
 # versions in a synchronised way.
 set(PROJECT_VERSION_MAJOR "0")
 set(PROJECT_VERSION_MINOR "2")
-set(PROJECT_VERSION_PATCH "9")
+set(PROJECT_VERSION_PATCH "10")
 set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
 
 # set .so library version / following libtool scheme

=== debian/changelog ===
libtoxcore (0.2.10-1build2) eoan; urgency=medium

  * No-change upload with strops.h and sys/strops.h removed in glibc.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Sep 2019 11:00:48 +0000

libtoxcore (0.2.10-1build1) eoan; urgency=medium

  * No-change rebuild against libvpx6

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 08 Aug 2019 15:34:58 +0000

libtoxcore (0.2.10-1) unstable; urgency=medium

  * New upstream release
  * Fix autopkgtest

 -- Yangfl <mmyangfl@gmail.com>  Thu, 04 Jul 2019 16:39:19 +0800

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: libtoxcore
 Priority: optional
-Maintainer: Yangfl <mmyangfl@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Yangfl <mmyangfl@gmail.com>
 Build-Depends:
  debhelper (>= 12~),
  cmake,

=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,7 @@
 	dh build --buildsystem=cmake
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DTEST_TIMEOUT_SECONDS=120
+	dh_auto_configure -- -DTEST_TIMEOUT_SECONDS=120 -DSTRICT_ABI=ON
 
 # iphy@#toktok: some of the tests use 100 ports
 # And tox limits the range of ports it tries to 33445-33545 (101 ports)

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%toxcore-$1.tar.gz%,pgpsigurlmangle=s%archive/v(\d[\d.]*)\.tar\.gz%releases/download/v$1/c-toxcore-$1.tar.gz.asc%" \
   https://github.com/TokTok/c-toxcore/releases \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## libtoxcore 0.2.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,7 +30,7 @@
 # versions in a synchronised way.
 set(PROJECT_VERSION_MAJOR "0")
 set(PROJECT_VERSION_MINOR "2")
-set(PROJECT_VERSION_PATCH "10")
+set(PROJECT_VERSION_PATCH "12")
 set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
 
 # set .so library version / following libtool scheme
@@ -82,6 +82,11 @@
   message(STATUS "Supported C++ compiler features = ${CMAKE_CXX_COMPILE_FEATURES}")
 endif()
 
+option(EXECUTION_TRACE "Print a function trace during execution (for debugging)" OFF)
+if(EXECUTION_TRACE)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -finstrument-functions")
+endif()
+
 set(MIN_LOGGER_LEVEL "" CACHE STRING "Logging level to use (TRACE, DEBUG, INFO, WARNING, ERROR)")
 if(MIN_LOGGER_LEVEL)
   if(("${MIN_LOGGER_LEVEL}" STREQUAL "TRACE") OR
@@ -104,6 +109,8 @@
 if(USE_STDERR_LOGGER)
   add_definitions(-DUSE_STDERR_LOGGER=1)
 endif()
+
+option(NON_HERMETIC_TESTS "Whether to build and run tests that depend on an internet connection" OFF)
 
 option(BUILD_TOXAV "Whether to build the tox AV library" ON)
 option(MUST_BUILD_TOXAV "Fail the build if toxav cannot be built" OFF)
@@ -234,6 +241,7 @@
 set(toxcore_SOURCES ${toxcore_SOURCES}
   toxcore/tox_api.c
   toxcore/tox.c
+  toxcore/tox_private.h
   toxcore/tox.h)
 set(toxcore_API_HEADERS ${toxcore_API_HEADERS} ${toxcore_SOURCE_DIR}/toxcore/tox.h^tox)
 
@@ -357,12 +365,3 @@
 #
 # :: Automated regression tests: create a tox network and run integration tests
 #
-################################################################################
-
-add_library(misc_tools
-  testing/misc_tools.c
-  testing/misc_tools.h)
-target_link_modules(misc_tools toxcore)
-
-set(TEST_TIMEOUT_SECONDS "" CACHE STRING "Limit runtime of each test to the number of seconds specified")
-

=== debian/changelog ===
libtoxcore (0.2.12-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.5.0
  * Bump debhelper compat to 13
  * Add upstream metadata

 -- Yangfl <mmyangfl@gmail.com>  Wed, 06 May 2020 02:42:32 +0800

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: libtoxcore
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Yangfl <mmyangfl@gmail.com>
+Maintainer: Yangfl <mmyangfl@gmail.com>
 Build-Depends:
- debhelper (>= 12~),
+ debhelper-compat (= 13),
  cmake,
  pkg-config,
  libconfig-dev,
@@ -11,7 +10,8 @@
  libopus-dev,
  libsodium-dev,
  libvpx-dev,
-Standards-Version: 4.3.0
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
 Section: libs
 Homepage: https://tox.chat
 Vcs-Git: https://salsa.debian.org/yangfl-guest/c-toxcore.git

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+export DEB_LDFLAGS_MAINT_APPEND =
 
 
 %:
@@ -20,6 +20,6 @@
 
 # iphy@#toktok: some of the tests use 100 ports
 # And tox limits the range of ports it tries to 33445-33545 (101 ports)
-override_dh_auto_test:
+#override_dh_auto_test:
 #	dh_auto_test --no-parallel
 # buggy - fail nearly everytime

## libtoxcore 0.2.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,7 @@
 cmake_policy(VERSION 2.8.12)
 project(toxcore)
 
-set(CMAKE_MODULE_PATH ${toxcore_SOURCE_DIR}/cmake)
+list(APPEND CMAKE_MODULE_PATH ${toxcore_SOURCE_DIR}/cmake)
 
 ################################################################################
 #
@@ -30,7 +30,7 @@
 # versions in a synchronised way.
 set(PROJECT_VERSION_MAJOR "0")
 set(PROJECT_VERSION_MINOR "2")
-set(PROJECT_VERSION_PATCH "12")
+set(PROJECT_VERSION_PATCH "13")
 set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
 
 # set .so library version / following libtool scheme
@@ -114,6 +114,13 @@
 
 option(BUILD_TOXAV "Whether to build the tox AV library" ON)
 option(MUST_BUILD_TOXAV "Fail the build if toxav cannot be built" OFF)
+
+if(MSVC)
+  option(MSVC_STATIC_SODIUM "Whether to link libsodium statically for MSVC" OFF)
+  if(MSVC_STATIC_SODIUM)
+    add_definitions(-DSODIUM_STATIC=1 -DSODIUM_EXPORT)
+  endif()
+endif()
 
 include(Dependencies)
 
@@ -356,12 +363,6 @@
 #
 unit_test(toxav ring_buffer)
 unit_test(toxav rtp)
+unit_test(toxcore DHT)
 unit_test(toxcore crypto_core)
 unit_test(toxcore mono_time)
-unit_test(toxcore ping_array)
-unit_test(toxcore util)
-
-################################################################################
-#
-# :: Automated regression tests: create a tox network and run integration tests
-#

=== debian/changelog ===
libtoxcore (0.2.13-1) unstable; urgency=medium

  * New upstream release
    * Fix CVE-2021-44847 (Closes: #1001711)
  * Bump Standards-Version to 4.6.0

 -- Yangfl <mmyangfl@gmail.com>  Tue, 21 Dec 2021 15:49:21 +0800

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  libsodium-dev,
  libvpx-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Section: libs
 Homepage: https://tox.chat
 Vcs-Git: https://salsa.debian.org/yangfl-guest/c-toxcore.git

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%toxcore-$1.tar.gz%,pgpsigurlmangle=s%archive/refs/tags/v(\d[\d.]*)\.tar\.gz%releases/download/v$1/c-toxcore-$1.tar.gz.asc%" \
   https://github.com/TokTok/c-toxcore/releases \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
